use strict;

use DE_EPAGES::Core::API::Script qw ( RunScript );
use Test::More;
use Test::Exception;
use DE_EPAGES::OneSaas::API::Connection qw ( CheckOneSaasRedirectURL );

sub Main {
    testUrl();
    done_testing();
}

sub testUrl {
    throws_ok sub { CheckOneSaasRedirectURL(undef); }, qr/PARAMETER_MISSING/, 'missing parameter';
    throws_ok sub { CheckOneSaasRedirectURL(''); }, qr/FORMAT_NOT_URL/, 'missing parameter (empty)';
    throws_ok sub { CheckOneSaasRedirectURL('xxxx'); }, qr/FORMAT_NOT_URL/, 'invalid url';
    throws_ok sub { CheckOneSaasRedirectURL('https://epagesTest.app.onesaas.com.ru/admin/connecttoplugin/completeauthorization/ePages'); }, qr/INVALID_URL/, 'hacked url';
    throws_ok sub { CheckOneSaasRedirectURL('http://epagesTest.app.onesaas.com/admin/connecttoplugin/completeauthorization/ePages'); }, qr/INVALID_URL/, 'http url';
    CheckOneSaasRedirectURL('https://epagesTest.app.onesaas.com/admin/connecttoplugin/completeauthorization/ePages');
    pass('valid url');

    CheckOneSaasRedirectURL('https://p2.os2.snowsparkle.com/admin/connecttoplugin/completeauthorization/ePages');
    pass('public staging url');

    CheckOneSaasRedirectURL('https://paulopolis.staging.onesaas.com/admin/connecttoplugin/completeauthorization/ePages');
    pass('development url');
}

RunScript( Sub => \&Main );
